<template>
  <div class="app-container">
    <div class="operation">
      <el-button class="success" @click="handleExamine">审核</el-button>
      <el-button class="export" style="float: right;margin-right: 10px;" @click="form_export">导出</el-button>
    </div>
    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.cowclassid" placeholder="牲畜类别" class="filter-item" style="width: 150px;" clearable>
        <el-option v-for="(item,index) in livestockTypeList" :key="index" :label="item.mixname" :value="item.id" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.feedid" placeholder="饲料名称" class="filter-item" style="width: 150px;" clearable>
        <el-option v-for="(item,index) in feedNameList" :key="index" :label="item.fname" :value="item.id" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.ischarge" placeholder="是否审核" class="filter-item" style="width: 150px;" clearable>
        <el-option v-for="(item,index) in isAuditList" :key="index" :label="item.name" :value="item.id" />
      </el-select>
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="form_clear">重置</el-button>
    </div>

    <div class="table">
      <el-table :key="table.tableKey" v-loading="table.listLoading" element-loading-text="给我一点时间" :data="table.list" border fit highlight-current-row style="width: 100%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed" @selection-change="change_table_selection">
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="业务日期" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.usedate }}</span>
          </template>
        </el-table-column>
        <el-table-column label="牲畜类别" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.cowclass }}</span>
          </template>
        </el-table-column>
        <el-table-column label="饲料名称" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.feedname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="库存重量（kg）" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.repertoryweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="计划重量（kg）" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.planweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="设备实测重量（kg）" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.actweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="出库重量（kg）" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.operateweight }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.operateweight" placeholder="最多保留两位小数" type="number" :step="0.01" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="备注（kg）" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.remark }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.remark" placeholder="1-32个字符" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" maxlength="32" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="是否审核" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.ischarge == 1">是</span>
            <span v-else>否</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="150" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <!-- 编辑 -->
            <el-button v-if="row.isUpdate && row.ischarge !== 1" class="miniSuccess" @click="form_edit(row)">编辑</el-button>
            <!-- 编辑保存 -->
            <el-button v-if="row.isUpdateSave" :disabled="isokDisable" class="miniSuccess" @click="form_edit_save(row)">保存</el-button>
            <el-button v-if="row.isUpdateSave" class="minCancel" @click="edit_cancel(row)">取消</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
  </div>

</template>

<script>
import { GetDataByName, GetDataByNames, checkButtons, calculativeWidth, PostDataByName, failproccess, ExecDataByConfig } from '@/api/common'
import { MessageBox } from 'element-ui'
import Cookies from 'js-cookie'
import { parseTime } from '@/utils/index.js'
export default {
  name: 'SystemConsumption',
  data() {
    return {

      livestockTypeList: [], // 牲畜类别
      feedNameList: [{ id: 0, name: '羊草' }, { id: 1, name: '小苏打' }], // 饲料名称
      isAuditList: [{ id: '1', name: '是' }, { id: '0', name: '否' }], // 是否审核
      send_select_list: [
        { name: 'getFeedListEnable', offset: 0, pagecount: 0, parammaps: { pastureid: Cookies.get('pastureid') } },
        { name: 'getCowclassListEnable', offset: 0, pagecount: 0, parammaps: { pastureid: Cookies.get('pastureid') } }
      ],
      table: {
        getdataListParm: {
          name: 'getFeeduseList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            inputDatetime: '',
            pastureid: Cookies.get('pastureid'),
            startTime: '',
            stopTime: '',
            usetype: '系统用量',
            feedid: '',
            cowclassid: '',
            ischarge: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true
      },
      selectList: [],
      requestParam: {},
      isokDisable: false,
      isRoleEdit: [],
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' }
    }
  },

  created() {
    this.get_auto_buttons()
    this.get_select_list()
    this.get_table_data()
  },

  methods: {
    get_auto_buttons() {
      const Edit = 'SystemConsumption'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    get_select_list() {
      GetDataByNames(this.send_select_list).then(response => {
        this.feedNameList = response.data.getFeedListEnable.list
        this.livestockTypeList = response.data.getCowclassListEnable.list
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    get_table_data() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'Edit', false) // 编辑
            this.$set(response.data.list[i], 'NoEdit', true) // 不可编辑/输入
            this.$set(response.data.list[i], 'isUpdate', true) // 编辑操作
            this.$set(response.data.list[i], 'isUpdateSave', false) // 编辑保存
          }
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },
    form_clear() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.feedid = ''
      this.table.getdataListParm.parammaps.cowclassid = ''
      this.table.getdataListParm.parammaps.ischarge = ''
      this.table.getdataListParm.offset = 1
    },
    form_edit(row) {
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      // 编辑true,不可编辑false
      row.Edit = true
      row.NoEdit = false
      // 编辑false,编辑保存true
      row.isUpdate = false
      row.isUpdateSave = true
    },
    form_edit_save(row) {
      console.log('点击了编辑保存', row)
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam.name = 'updateFeeduse'
      this.requestParam.parammaps = {}
      this.requestParam.parammaps.pastureid = row.pastureid
      this.requestParam.parammaps.id = row.id
      this.requestParam.parammaps.remark = row.remark
      this.requestParam.parammaps.operateweight = row.operateweight
      PostDataByName(this.requestParam).then(response => {
        console.log('新增保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.get_table_data()
        } else {
          failproccess(response, this.$notify)
        }
      })
    },
    edit_cancel(row) {
      console.log('点击了编辑取消')
      // 编辑false,不可编辑true
      row.Edit = false
      row.NoEdit = true
      // 编辑true,编辑保存false
      row.isUpdate = true
      row.isUpdateSave = false
      this.get_table_data()
    },
    change_table_selection(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    handleExamine() {
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择需要审核的单据', duration: 2000 })
      } else {
        for (let i = 0; i < this.selectList.length; i++) {
          if (this.selectList[i].ischarge == 1) {
            this.$message({ type: 'error', message: '单据不可重复审核，请重新选择', duration: 2000 })
            return
          }
        }
        MessageBox.confirm('是否确认审核系统用量?', '提示', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList } }
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = {            'name': 'chargeFeedstorageuse', 'type': 'e', 'parammaps': {
              id: '@insertSpotList.id',
              pastureid: '@insertSpotList.pastureid',
              operateweight: '@insertSpotList.operateweight'
            }          }
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('审核保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '成功', type: 'success', duration: 2000 })
              this.get_table_data()
            }
          })
        })
      }
    },
    form_export() {
      console.log('点击了导出')
    }

  }
}
</script>
<style lang="scss" scoped>
.operation {
  margin-top: 10px;
}
.search {
  margin-top: 10px;
}
.table {
  margin-top: 10px;
}
</style>
